unit Q3_U;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, ExtCtrls, StdCtrls, Buttons;

  Const iMaxRows = 5;
        iMaxCols = 6;
        iMaxPerTable = 9;
        fname = 'Bookings.txt';


  Type t2DArray = Array[1..iMaxRows,1..iMaxCols] of Integer ;

type
  TfrmQuestion3 = class(TForm)
    pnlOutPut: TPanel;
    pnlButtons: TPanel;
    sgdTables: TStringGrid;
    bbnClose: TBitBtn;
    btnPerFree: TButton;
    lblTables: TLabel;
    lblOutput: TLabel;
    memOutput: TMemo;
    btnBookSeats: TButton;
    btnTestBookings: TButton;
    lbxData: TListBox;
    btnSaveBookings: TButton;
    procedure Initialise(Sender: TObject);
    procedure btnPerFreeClick(Sender: TObject);
    procedure DisplayTables(arrTables :t2DArray );
    function PerFree ( arrTables : t2DArray): Real;
    Procedure Book ( Var arrTables : t2DArray  ; iRequested : Integer );
    procedure btnBookSeatsClick(Sender: TObject);
    procedure btnTestBookingsClick(Sender: TObject);
    procedure btnSaveBookingsClick(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }

  end;

var
  frmQuestion3: TfrmQuestion3;

implementation

Var  arrTables   : t2DArray;
{$R *.dfm}
//==========================================================================================================================
function TfrmQuestion3.PerFree ( arrTables : t2DArray): Real;

Begin
  // Question / Vraag 3.1
end;
//==========================================================================================================================
Procedure TfrmQuestion3.btnPerFreeClick(Sender: TObject);
begin
  // Question  / Vraag 3.1
   DisplayTables(arrTables );
end;
//==========================================================================================================================
procedure TfrmQuestion3.btnSaveBookingsClick(Sender: TObject);

Begin
   // Question  / Vraag 3.2
end;
//==========================================================================================================================
Procedure TfrmQuestion3.Book ( Var arrTables : t2DArray  ; iRequested : Integer );

Begin
   // Question  / Vraag 3.3
end;
//==========================================================================================================================
procedure TfrmQuestion3.DisplayTables(arrTables :t2DArray);
Const sCols = 'ABCDEFG';
Var iRow, iCol : Integer;
Begin
  // Do not alter or add code in this procedure
  For iRow := 1 to iMaxRows Do
    For iCol := 1 to iMaxCols do sgdTables.Cells[iCol, iRow] := IntToStr(arrTables [ iRow , iCol ]);
  // label grid borders
  For iCol := 1 to iMaxCols do sgdTables.Cells[iCol, 0] := sCols[iCol];
  For iRow := 1 to iMaxRows do sgdTables.Cells[0,iRow] := IntToStr(iRow);

End;
//==========================================================================================================================
procedure TfrmQuestion3.Initialise(Sender: TObject);
Var  iCounter, iCol , iRow: Integer;
     TextF :TextFile;
     sLine : String;
begin
  // Do not alter or add code in this procedure
  // read data from text file
    AssignFile(TextF, fname);
    Reset(TextF);
    For iRow := 1 to iMaxRows Do
    Begin
      Readln(TextF, sLine);
      For iCol := 1 to iMaxCols Do arrTables[iRow,iCol] := StrToInt(sLine[iCol]);
     End;
    CloseFile(TextF);
    DisplayTables(arrTables);
end;
//==========================================================================================================================
procedure TfrmQuestion3.btnBookSeatsClick(Sender: TObject);
Var iRequested : Integer;
begin
   // Do not alter or add code in this procedure
   memOutput.Clear;
   iRequested := StrToInt(InputBox('Table Bookings','Enter number of seats you want to book',''));
   Book(arrTables,iRequested);
   DisplayTables(arrTables);
end;
//==========================================================================================================================
procedure TfrmQuestion3.btnTestBookingsClick(Sender: TObject);
Var  iCounter : Integer;
begin
  // Do not alter or add code in this procedure
  For iCounter := 0 to lbxData.Items.Count -1 Do
  Book(arrTables , StrToInt(lbxData.Items[iCounter]));
  DisplayTables(arrTables );
end;
//==========================================================================================================================

end.
